// MemBrain C Code export library V06.00.00.00

/*
--- License information and liability disclaimer ---
------------------
The source code exported by MemBrain including all supplementary source code
provided as part of the MemBrain installation is subject to licensing according
to the terms indicated in the license agreement that is displayed when
installing the MemBrain software.

You can also download and view this license agreement on the MemBrain
homepage (http://www.membrain-nn.de).

The terms of the license agreement do especially prohibit the commercial use of
any of the MemBrain source code items for a commercial purpose except the
user or company that intends to use the code in a commercial way is a
commercially registered MemBrain user and the owner of a corresponding commercial
MemBrain license key.

The MemBrain program and all associated supplementary software including but not
limited to the MemBrain DLL and all MemBrain generated source code are distributed
"as is". No warranty of any kind is expressed or implied. You use it at your own risk.
Thomas Jetter will not be liable for data loss, damages and loss of profits or
properties or any other kind of damages or loss caused by use or misuse of this
software.

Copyright 2003 - 2019 Thomas Jetter
*/


#ifndef _NEURAL_LINK_H_
#define _NEURAL_LINK_H_

/// Parameters of a neural link
typedef struct
{
  MB_FLOAT           weight;       ///< Link weight
  T_NEURON_COUNT    sourceIdx;    ///< Index of source neuron

#ifdef LINK_LENGTHS
  T_LINK_LEN  len;                ///< Link length
#endif

} SNeuralLinkParms;


#ifdef __cplusplus
extern "C"
{
#endif


/// Get the current output signal of the given link
MB_FLOAT NeuralLinkGetOutput(T_LINK_IDX index);

#ifdef ACT_FUNC_MIN_EUCLID_DIST
/// Get the neuron output signal that lead to the current output signal of the link
MB_FLOAT NeuralLinkGetInNeuronOutput(T_LINK_IDX index);
#endif

#ifdef __cplusplus
}
#endif

#endif