// MemBrain C Code export library V06.00.00.00

/*
--- License information and liability disclaimer ---
------------------
The source code exported by MemBrain including all supplementary source code
provided as part of the MemBrain installation is subject to licensing according
to the terms indicated in the license agreement that is displayed when
installing the MemBrain software.

You can also download and view this license agreement on the MemBrain
homepage (http://www.membrain-nn.de).

The terms of the license agreement do especially prohibit the commercial use of
any of the MemBrain source code items for a commercial purpose except the
user or company that intends to use the code in a commercial way is a
commercially registered MemBrain user and the owner of a corresponding commercial
MemBrain license key.

The MemBrain program and all associated supplementary software including but not
limited to the MemBrain DLL and all MemBrain generated source code are distributed
"as is". No warranty of any kind is expressed or implied. You use it at your own risk.
Thomas Jetter will not be liable for data loss, damages and loss of profits or
properties or any other kind of damages or loss caused by use or misuse of this
software.

Copyright 2003 - 2019 Thomas Jetter
*/


#ifndef _NEURAL_NET_H_
#define _NEURAL_NET_H_

#include "NeuralNetDef.h"


#ifdef __cplusplus
extern "C"
{
#endif

/// Initialize and reset the neural net. Call this function at least once in first place!!
void NeuralNetInitAndReset(void);

/// Let the net perform one think step
void NeuralNetThinkStep(void);

#if MB_IN_NEURON_COUNT != 0
/// Apply an activation value to an input neuron. <inputIdx> can range from 0 to MB_IN_NEURON_COUNT - 1
BOOL NeuralNetApplyInputAct(T_NEURON_COUNT inputIdx, T_ACT_FLOAT act);
#endif

/// Get the activation value of an output neuron. <outputIdx> can range from 0 to MB_OUT_NEURON_COUNT - 1
BOOL NeuralNetGetOutputAct(T_NEURON_COUNT outputIdx, T_ACT_FLOAT* pAct);

/// Get the output value of an output neuron. <outputIdx> can range from 0 to MB_OUT_NEURON_COUNT - 1
BOOL NeuralNetGetOutputOut(T_NEURON_COUNT outputIdx, MB_FLOAT* pOut);

#ifdef __cplusplus
}
#endif

#endif