/// Auto-generated neural net C Code header file by MemBrain V11.05.01.00

/*
--- License information and liability disclaimer ---
------------------
The source code exported by MemBrain including all supplementary source code
provided as part of the MemBrain installation is subject to licensing according
to the terms indicated in the license agreement that is displayed when
installing the MemBrain software.

You can also download and view this license agreement on the MemBrain
homepage (https://www.membrain-nn.de).

The terms of the license agreement do especially prohibit the commercial use of
any of the MemBrain source code items for a commercial purpose except the
user or company that intends to use the code in a commercial way is a
commercially registered MemBrain user and the owner of a corresponding commercial
MemBrain license key.

The MemBrain program and all associated supplementary software including but not
limited to the MemBrain DLL and all MemBrain generated source code are distributed
"as is". No warranty of any kind is expressed or implied. You use it at your own risk.
Thomas Jetter will not be liable for data loss, damages and loss of profits or
properties or any other kind of damages or loss caused by use or misuse of this
software.

Copyright 2003 - 2019 Thomas Jetter
*/


#ifndef _NEURAL_NET_DEF_H_
#define _NEURAL_NET_DEF_H_

#include "NN_Types.h"

/// types to optimize code according to net analysis
typedef	UINT8	T_NEURON_COUNT;

typedef	UINT8	T_LINK_LEN;

typedef	UINT8	T_OUT_IDX;

typedef	UINT8	T_FIRE_DELAY;

typedef	UINT16	T_LINK_IDX;

typedef	UINT8	T_IN_LINK_COUNT;

typedef	FLOAT64	T_ACT_FLOAT;

typedef	FLOAT64	T_NORM_FLOAT;

typedef	FLOAT64	MB_FLOAT;

/// preprocessor directives to optimize code according to net analysis...

/// One or more output neurons make use of normalization settings
#define	OUTPUT_NORMALIZATION	

/// One or more neurons use fire thresholds which cause random output behavior
#define	FIRE_THRESHOLDS	

/// Activation function LOGISTIC is in use
#define	ACT_FUNC_LOGISTIC	


/// Neurons need an output buffer for this net
#define	NEED_OUT_BUFFER	

/// Neurons in this net make use of input function which is not identity
#define	NEED_INPUT_FUNC	

/// Normalization code needed
#define	NORMALIZATION	

/// The logistic exponent to be used
extern const MB_FLOAT MB_EXP_LOG;

/// One or more neurons use fire thresholds that can result in a random firing. --> The floating point random unit is needed, too.
#define	NEED_FLOAT_RAND	

/// Number of neurons in the input layer
#define	MB_IN_NEURON_COUNT	45

/// Number of hidden neurons in all other layers (including context layer)
#define	MB_HID_NEURON_COUNT	24

/// Number of neurons in the output layer
#define	MB_OUT_NEURON_COUNT	1

/// Size of output buffer array for the whole net
#define	MB_OUT_ARRAY_SIZE	70

/// include definitions of neurons and links
#include "Neuron.h"
#include "NeuralLink.h"

/// parameter array for all neurons
extern const SNeuronParms NEURON_PARMS[];

/// Additional parameters for all hidden neurons
extern const SHiddenNeuronParms NEURON_PARMS_HIDDEN[];

/// additional parameters of all output neurons
extern const SOutputNeuronParms NEURON_PARMS_OUTPUT[];

/// parameters of all links in the net
extern const SNeuralLinkParms NEURAL_LINK_PARMS[];

/// number of neurons in the whole net
#define MB_NEURON_COUNT   (MB_IN_NEURON_COUNT + MB_HID_NEURON_COUNT + MB_OUT_NEURON_COUNT)

#endif // #ifndef _NEURAL_NET_DEF_H_

