// MemBrain C Code export library V06.00.00.00

/*
--- License information and liability disclaimer ---
------------------
The source code exported by MemBrain including all supplementary source code
provided as part of the MemBrain installation is subject to licensing according
to the terms indicated in the license agreement that is displayed when
installing the MemBrain software.

You can also download and view this license agreement on the MemBrain
homepage (http://www.membrain-nn.de).

The terms of the license agreement do especially prohibit the commercial use of
any of the MemBrain source code items for a commercial purpose except the
user or company that intends to use the code in a commercial way is a
commercially registered MemBrain user and the owner of a corresponding commercial
MemBrain license key.

The MemBrain program and all associated supplementary software including but not
limited to the MemBrain DLL and all MemBrain generated source code are distributed
"as is". No warranty of any kind is expressed or implied. You use it at your own risk.
Thomas Jetter will not be liable for data loss, damages and loss of profits or
properties or any other kind of damages or loss caused by use or misuse of this
software.

Copyright 2003 - 2019 Thomas Jetter
*/

#ifndef _RANDOM_H_
#define _RANDOM_H_


#ifdef __cplusplus
extern "C"
{
#endif

/// Init random generator
void RandomInit(INT32 seed);

#if defined (NEED_FLOAT_RAND) || defined (NEED_INT_RAND)
/// Get a random value between 0 and 1
MB_FLOAT RandomGetRand01();
#endif

#ifdef NEED_INT_RAND
/// Get an integer random value between 0 and max
T_INT_RAND RandomGetIntRand(T_INT_RAND max);
#endif

#ifdef __cplusplus
}
#endif


#endif